Possibility of having 2 (or more) repositories with empty identifier

2015-03-17 00:49 - Toshi MARUYAMA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 2.6.4   

Resolution: Fixed Affected version: 2.6.3

Description

#19260#note-4

This patch (r14050) introduces the possibility of having 2 (or more) repositories with empty identifier.

Is this something intendend?

 Maybe a self.save(validate: false) in clear_extra_info_of_changesets would have done the job too? (specially if the repository is

about to be deleted)

Associated revisions

Revision 14142 - 2015-03-20 11:20 - Jean-Philippe Lang

Don't allow 2 repositories with blank identifier (#19400).

Revision 14143 - 2015-03-20 11:23 - Jean-Philippe Lang

Don't validate the repository when updating/clearing extra info (#19400).

Revision 14147 - 2015-03-21 09:26 - Jean-Philippe Lang

Merged r14142 and r14143 (#19400).

Revision 14148 - 2015-03-21 09:29 - Jean-Philippe Lang

Merged r14142 and r14143 (#19400).

Revision 14156 - 2015-04-11 08:27 - Jean-Philippe Lang

Fixed that 2 repositories can be created with blank/nil identifier (#19400).

Revision 14161 - 2015-04-12 08:53 - Jean-Philippe Lang

Fixed tests failures (#19400).

Revision 14197 - 2015-04-25 09:18 - Jean-Philippe Lang

Merged r14156 and r14161 (#19400).

Revision 14198 - 2015-04-25 09:18 - Jean-Philippe Lang

Merged r14156 and r14161 (#19400).

History

#1 - 2015-03-17 00:50 - Toshi MARUYAMA

- Target version changed from 2.6.3 to 2.6.4

#2 - 2015-03-17 01:16 - Nicolas Rodriguez

- File Configuration - test - Redmine.png added

Maybe I should precise the context : I'm the maintainer of Redmine Git Hosting plugin and this patch brings the side effect describe above.

2025-05-02 1/2

https://www.redmine.org/issues/19260#note-4
https://www.redmine.org/projects/redmine/repository/svn/revisions/14050
https://github.com/jbox-web/redmine_git_hosting


I dug this issue and the decision about repository identifier presence is not very clear.

This comment of jpl let me think that only one repository per project can have empty identifier.

Can you confirm (or not) that it's the case?

I've put a screenshot of the issue in attachment.

#3 - 2015-03-21 09:24 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

#4 - 2015-03-21 09:30 - Jean-Philippe Lang

- Subject changed from possibility of having 2 (or more) repositories with empty identifier to Possibility of having 2 (or more) repositories with empty

identifier

- Status changed from Resolved to Closed

- Affected version set to 2.6.3

#5 - 2015-04-04 03:02 - Nicolas Rodriguez

Hi!

Thanks for your patch! But I think there still an issue... I test Redmine Git Hosting plugin with Travis (as you do) and one the test is still failing : 

https://travis-ci.org/jbox-web/redmine_git_hosting.

As you can see I test Redmine Git Hosting with Redmine 2.6.2/3.0.0 (from tarball) and 2.6-stable/3.0-stable (from SVN) and both stable branch are

broken. (from plugin point of view).

It's about identifier uniqueness.

Here the test :

before do

  @repository_1 = create_git_repository(project: @project_child, is_default: true) # Create a repo in database

 with no identifier

end

describe "Test uniqueness" do

  context "when blank identifier is already taken by a repository" do

    it { expect(build_git_repository(project: @project_child, identifier: '')).to be_invalid } # This one fail

s

  end

  context "when set as default and blank identifier is already taken by a repository" do

    it { expect(build_git_repository(project: @project_child, identifier: '', is_default: true)).to be_invalid

 } # This one pass

  end

....

 It seems that depending on the "default status" of a repository you can still create 2 repositories with blank identifier.

#6 - 2015-04-04 04:17 - Toshi MARUYAMA

- Status changed from Closed to Reopened

#7 - 2015-04-25 09:18 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Files

Configuration - test - Redmine.png 58.8 KB 2015-03-17 Nicolas Rodriguez
http://www.redmine.org/issues/779
http://www.redmine.org/issues/779#note-109
